﻿<AML>
 <Item type="Method" id="94DB4FC3260649B18C868F40F17E52C9" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_aged_payables
            Created By/Company:		SolidCAD
            Creation Date:			2018-01-23
            Description:
                Getting Required Information for Report.

            Hooks:
                Type:		Form : acc_aged_payables
                Event:		button0 ( onClick )
                Called by:	acc_aged_payables_call

            Inputs:
                Vendor,
                Currency,
                From Date,
                To Date 

            Revisions:
                Rev Date		Modified By			Description
                2018-07-20		Chan				Add Propert(pop_own_amount,acc_currencycode)
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_aged_payables";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var acc_from_date = this.getProperty("acc_from_date", "");
                var acc_to_date = this.getProperty("acc_to_date", "");
                var acc_customer_name = this.getProperty("acc_customer_name", "");
                var acc_currency_filter = this.getProperty("acc_currency_filter", "");

                string date_condition = "";
                date_condition = "  and (Convert(Date,innovator.ConvertToLocal(acc_date,DEFAULT),111)  Between Convert(Date,'" + acc_from_date + "',111) "
                    + " and  Convert(Date,'" + acc_to_date + "',111))";

                var name_condition = "";
                if (acc_customer_name != "")
                {
                    name_condition = " and Vendor.name= '" + acc_customer_name + "'";
                }

                var clear_report_data = myInnovator.applySQL("DELETE FROM innovator.acc_aged_payables");

                var qurey = "select pop_total_amount as base_pop_total_amount,POP_CURRENCY_RATE as acc_rate,acc_sg_credit as pop_sg_total_amount,pop_own_amount ,acc_credit as pop_total_amount,acc_currencycode,POP_PURCHASE_INVOICE.erp_company,innovator.ConvertToLocal(POP_PURCHASE_INVOICE.pop_invoice_date,DEFAULT) as pop_invoice_date,VENDOR.ID as vendor_id,name, POP_PURCHASE_INVOICE.pop_invoice_desc,pop_gst_amount,pop_invoice_no from innovator.POP_PURCHASE_INVOICE inner join innovator.ACC_JOURNAL_HEADER on ACC_JOURNAL_HEADER.acc_pop_voucher_reference=POP_PURCHASE_INVOICE.id inner join innovator.ACC_JOURNAL_DETAILS on ACC_JOURNAL_DETAILS.SOURCE_ID=ACC_JOURNAL_HEADER.id left join innovator.VENDOR on VENDOR.ID=POP_PURCHASE_INVOICE.POP_VENDOR inner join innovator.acc_currency on acc_currency.id=POP_PURCHASE_INVOICE.pop_currency where isnull(POP_OWN_AMOUNT,0)<>0 and ACC_SYSTEMACCOUNTID='Account Payable' and acc_transactiontype='Purchase'" + name_condition + date_condition + "order by name,Convert(Date,pop_invoice_date,111) ,pop_invoice_no ASC";

                Item _get_data = myInnovator.applySQL(qurey);

                var _get_data_count = _get_data.getItemCount();
                var vendor_id = "";

                if (_get_data_count > 0)
                {
                    for (int i = 0; i < _get_data_count; i++)
                    {
                        var j = i + 1;
                        var _get_data_result = _get_data.getItemByIndex(i);
                        var sop_invoice_date = _get_data_result.getProperty("pop_invoice_date");
                        DateTime dt_acc_date = DateTime.Parse(sop_invoice_date);

                        dt_acc_date = new DateTimeOffset(dt_acc_date, TimeSpan.FromHours(0)).ToLocalTime().DateTime;
                        var local_acc_date = dt_acc_date.ToString("yyyy-MM-dd");
                        DateTime dt_now_date = DateTime.Now;
                        TimeSpan difference = dt_now_date - dt_acc_date;
                        int days = Convert.ToInt32(difference.TotalDays);
                        var pop_total_amount = "0";
                        var sop_owing_amount = "0";
                        decimal d_owing_amount = 0;
                        var acc_rate = _get_data_result.getProperty("acc_rate");
                        sop_owing_amount = _get_data_result.getProperty("pop_own_amount");
                        var pop_own_amount = _get_data_result.getProperty("base_pop_total_amount");
                        var currency_result_1 = myInnovator.applyMethod("acc_SG_currency_info", "<currency_date>" + dt_acc_date + "</currency_date>");
                        var currency_count_1 = currency_result_1.getItemCount();
                        if (currency_count_1 > 0)
                        {
                            string sg_rate = currency_result_1.getProperty("acc_monthly_rate", "");
                            string sg_operator = currency_result_1.getProperty("acc_operator", "");
                            if (acc_currency_filter == "USD")
                            {
                                pop_total_amount = _get_data_result.getProperty("pop_total_amount");
                                d_owing_amount = Convert.ToDecimal(sop_owing_amount) / Convert.ToDecimal(acc_rate);
                                sop_owing_amount = d_owing_amount.ToString();

                            }
                            else
                            {
                                pop_total_amount = _get_data_result.getProperty("pop_sg_total_amount");
                                d_owing_amount = d_owing_amount = Convert.ToDecimal(sop_owing_amount) / Convert.ToDecimal(acc_rate) * Convert.ToDecimal(sg_rate);
                                sop_owing_amount = d_owing_amount.ToString();

                            }
                        }

                        var name = _get_data_result.getProperty("name");
                        var sop_invoice_no = _get_data_result.getProperty("pop_invoice_no");
                        var erp_company = _get_data_result.getProperty("erp_company");
                        var acc_currencycode = _get_data_result.getProperty("acc_currencycode");
                        vendor_id = _get_data_result.getProperty("vendor_id");

                        Item acc_aged_payables = myInnovator.newItem("acc_aged_payables", "add");
                        acc_aged_payables.setProperty("acc_name_of_customer", name);
                        acc_aged_payables.setProperty("acc_invoice_amount", pop_total_amount);
                        acc_aged_payables.setProperty("acc_receivable_amount", sop_owing_amount);
                        acc_aged_payables.setProperty("acc_invoice_date", local_acc_date);
                        acc_aged_payables.setProperty("acc_invoice_no", sop_invoice_no);
                        acc_aged_payables.setProperty("erp_company", erp_company);
                        acc_aged_payables.setProperty("acc_currency_filter", acc_currency_filter);
                        acc_aged_payables.setProperty("acc_customer_name", vendor_id);
                        acc_aged_payables.setProperty("acc_total_due", sop_owing_amount);
                        acc_aged_payables.setProperty("acc_to_date", acc_to_date);
                        acc_aged_payables.setProperty("acc_from_date", acc_from_date);

                        if (days >= 0 && days <= 30)
                        {
                            acc_aged_payables.setProperty("acc_current", sop_owing_amount);
                            acc_aged_payables.setProperty("acc_greaterthanthirty", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthanfortyfive", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthansixty", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthanninty", "0.00");
                        }
                        else if (days > 30 && days <= 45)
                        {
                            acc_aged_payables.setProperty("acc_greaterthanthirty", sop_owing_amount);
                            acc_aged_payables.setProperty("acc_current", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthanfortyfive", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthansixty", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthanninty", "0.00");
                        }
                        else if (days > 45 && days <= 60)
                        {
                            acc_aged_payables.setProperty("acc_greaterthanfortyfive", sop_owing_amount);
                            acc_aged_payables.setProperty("acc_current", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthanthirty", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthansixty", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthanninty", "0.00");
                        }
                        else if (days > 60 && days <= 90)
                        {
                            acc_aged_payables.setProperty("acc_greaterthansixty", sop_owing_amount);
                            acc_aged_payables.setProperty("acc_current", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthanthirty", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthanfortyfive", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthanninty", "0.00");
                        }
                        else
                        {
                            acc_aged_payables.setProperty("acc_greaterthanninty", sop_owing_amount);
                            acc_aged_payables.setProperty("acc_current", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthanthirty", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthanfortyfive", "0.00");
                            acc_aged_payables.setProperty("acc_greaterthansixty", "0.00");

                        }
                        acc_aged_payables.setProperty("acc_paging_no", j.ToString());
                        acc_aged_payables.setProperty("pop_own_amount", pop_own_amount);//2018-07-20
                        acc_aged_payables.setProperty("acc_currencycode", acc_currencycode);//2018-07-20
                        acc_aged_payables = acc_aged_payables.apply();
                        int icount = acc_aged_payables.getItemCount();
                        if (acc_aged_payables.isError())
                        {
                            return myInnovator.newError("Error While Adding Aging report.");
                        }
                    }
                }
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>acc_aged_payables</name>
 </Item>
</AML>